﻿-- ********************************************************************************
-- Halo Minimalistic
-- A minimalistic halo range display.
-- By: Shenton
--
-- FindRange.lua
--
-- This is not user friendly, and do not check for user errors.
-- It is used to gather information about items range
-- ex: aquire a target friendly or not
-- /hmp1 1000 10000 -- gather items with a spell and in range with IDs between 1000 and 10000
-- move closer
-- /hmp2 -- print items with a spell, in range and not gathered by /hmp1
--
-- Could be better, prettier, but you don't get disconnected, it cache every valid items and so it get the job done.
-- ********************************************************************************

local A = CreateFrame("Frame");

A.lastUpdate = 0;
A.iMin = 1000;
A.iMax = 2000;
A.i = 0;
A.i2 = 0;
A.phaseOne = nil;
A.phaseTwo = nil;
A.iStored = {};

A:SetScript("OnUpdate", function(self, elapsed)
    self.lastUpdate = self.lastUpdate + elapsed;

    if ( self.lastUpdate > 0.01 ) then
        if ( A.phaseOne ) then
            local name = GetItemInfo(A.i);

            if ( A.i2 > 10 ) then
                A.i2 = 0;
                A.i = A.i + 1;
            elseif ( A.i > A.iMax ) then
                A.phaseOne = nil;
                print("Phase one done.");
            elseif ( name ) then
                if ( IsItemInRange(A.i) == 1 ) then
                    A.iStored[A.i] = name;
                    print(("Item: %s (%d) added."):format(name, A.i));
                end

                A.i2 = 0;
                A.i = A.i + 1;
            else
                A.i2 = A.i2 + 1;
            end
        elseif ( A.phaseTwo ) then
            local name = GetItemInfo(A.i);

            if ( A.i2 > 10 ) then
                A.i2 = 0;
                A.i = A.i + 1;
            elseif ( A.i > A.iMax ) then
                A.phaseTwo = nil;
                print("Phase two done.");
            elseif ( name ) then
                if ( IsItemInRange(A.i) == 1 and not A.iStored[A.i] ) then
                    A.iStored[A.i] = name;
                    print(("Item: %s (%d) in range!!!"):format(name, A.i));
                end

                A.i2 = 0;
                A.i = A.i + 1;
            else
                A.i2 = A.i2 + 1;
            end
        end

        self.lastUpdate = 0;
    end
end);

local function PhaseOne()
    A.i = A.iMin;
    A.i2 = 0;
    A.lastUpdate = 0;
    A.iStored = {};
    A.phaseOne = 1;
    print("Phase one started!");
end

local function PhaseTwo()
    A.i = A.iMin;
    A.i2 = 0;
    A.lastUpdate = 0;
    A.phaseTwo = 1;
    print("Phase two started!");
end

_G["SLASH_HALOMINIPHASEONE1"] = "/hmp1";
function SlashCmdList.HALOMINIPHASEONE(args, box)
    local mi, ma = string.match(args, "^(%S*)%s*(.-)$");

    A.iMin = tonumber(mi);
    A.iMax = tonumber(ma);

    PhaseOne();
end

_G["SLASH_HALOMINIPHASETWO1"] = "/hmp2";
function SlashCmdList.HALOMINIPHASETWO()
    PhaseTwo();
end
